; Core/ARM/3/ARMCache.s
; ARMCache module for v3 ARM architectures
;
; 30/Sep/1999 ned

	AREA	ARMCache, CODE, READONLY

	; Include ARMCore constants
	INCLUDE ArmCacheH.s

	; Include zero page map
	INCLUDE Core/ARM/CommonH.s

	; Exports from this module
	EXPORT	ARMCache_Initialise
	EXPORT	ARMCache_Finalise
	EXPORT	ARMCache_Set
	EXPORT	ARMCache_EnableUCache
	EXPORT	ARMCache_DisableUCache
	EXPORT	ARMCache_FlushUCache

ARMCache_Initialise
	MOV	R0,#0
	MOV	PC, R14

ARMCache_Finalise
	MOV	R0,#0
	MOV	PC,R14

ARMCache_Set
	STMFD	R13!,{R4,R9}
	; R0=bits to set
	; R1=bits to clr
	BOARD_RETURNZPLOCATION R9
	; Ensure interrupts off
	MRS	R4,CPSR
	ORR	R3,R4,#IBit
	MSR	CPSR_all,R3

	LDR	R2,[R9,#HALZP_ARMCORE_CTRLREG]
	BIC	R2,R2,R1
	ORR	R2,R2,R0
	STR	R2,[R9,#HALZP_ARMCORE_CTRLREG]
	MCR	p15, 0, R2, c1, c0, 0

	MSR	CPSR_all,R4
	MOV	R0,#0
	LDMFD	R13!,{R4,R9}
	MOV	PC,R14

ARMCache_EnableUCache
	MOV	R0,#ARMCACHE_SETUCACHE
	MOV	R1,#0
	B	ARMCache_Set

ARMCache_DisableUCache
	MOV	R0,#0
	MOV	R1,#ARMCACHE_SETUCACHE
	B	ARMCache_Set

ARMCache_FlushUCache
	MCR	p15, 0, R0, c7, c0, 0

	MOV	R0,#0
	MOV	PC,R14

	END
