; CPUs/StrongARM/ARMMMU.s
; ARMMMU module for the AT91
;
; 29/Sep/1999 ned

	AREA	ARMMMU, CODE, READONLY

	; Include ARMMMU constants
	INCLUDE ArmMMUH.s

	; Include zero page map
	INCLUDE Core/ARM/CommonH.s

	; Exports from this module
	EXPORT	ARMMMU_Initialise
	EXPORT	ARMMMU_Set
	EXPORT	ARMMMU_BeginL1PageTableBuild
	EXPORT	ARMMMU_MakeL1PageTableEntries


ARMMMU_Initialise
	; On entry R9=ptr to zero space
	STMFD	R13!,{R0}
	LDR	R0,=0xa0000000				; ARM7TDMI
	STR	R0,[R9,#HALZP_ARMMMU_TTBREG]
	LDMFD	R13!,{R0}
	MOV	PC, R14

ARMMMU_Set
	; R0=bits to set
	; R1=bits to clr
	; R2=Translation Table Base if ARMMMU_SETTTB set
	STMFD	R13!,{R3,R4}
	LDR	R3,[R9,#HALZP_ARMCORE_CTRLREG]
	TST	R0,#ARMMMU_SETTTB
	MOVNE	R4,#1
	BICNE	R0,R0,#ARMMMU_SETTTB
	BIC	R3,R3,R1
	ORR	R3,R3,R2
	STR	R3,[R9,#HALZP_ARMCORE_CTRLREG]
	MCR	p15, 0, R3, c1, c0, 0
	CMP	R4,#0
	LDMNEFD	R13!,{R3,R4}
	MOVNE	PC, R14
	; Also set the TTB
	STR	R2,[R9,#HALZP_ARMMMU_TTBREG]
	MCR	p15, 0, R2, c2, c0, 0
	LDMFD	R13!,{R3,R4}
	MOV	PC, R14

ARMMMU_BeginL1PageTableBuild
	; R0=addr of proposed L1 page tables
	STMFD	R13!,{R0-R2}
	ADD	R1,R0,#16384
	MOV	R2,#0
1
	STR	R2,[R0],#4
	CMP	R0,R1
	BLO	%b01
	LDMFD	R13!,{R0-R2}
	MOV	PC,R14

ARMMMU_MakeL1PageTableEntries
	; R0=base of L1 page tables
	; R1=start section no
	; R2=start desired virtual addr
	; R3=end desired virtual addr
	; R4=desired domain, access permissions, caching & buffering of section
	STMFD	R13!,{R5}
1
	ORR	R5,R4,R2
	STR	R5,[R0,R1,LSL #2]
	ADD	R2,R2,#0x100000			; +1Mb
	ADD	R1,R1,#1			; Mb no +1
	CMP	R2,R3
	BLO	%b01
	LDMFD	R13!,{R5}
	; R0,R3,R4 preserved
	; R1,R2 updated
	MOV	PC,R14

	
	END
