/* Core/io/DebugIO.h

01/Oct/1999 ned
*/

#include "Core/ARM/common.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct DbgIO_UARTDetails_t
{
	int initialised:1;
	HALError *(*initialise)(HALUARTBlk *, void *, int);
	HALError *(*finalise)(HALUARTBlk *);
	HALError *(*send)(HALUARTBlk *, const char *, int no);
	HALError *(*get)(HALUARTBlk *, char *, int no);
} DbgIO_UARTDetails;


/* DbgIO.c */

extern HALError *DbgIO_Initialise(void);

extern HALError *DbgIO_Finalise(void);

extern HALError *DbgIO_Set(DbgIO_UARTDetails *, HALUARTBlk *);

extern HALError *DbgIO_Write0(const char *);

extern HALError *DbgIO_WriteC(const char);

extern HALError *DbgIO_ReadC(char *);

/* fancyprint.c */
extern HALError *DbgIO_WriteF(const char *, ...);

#ifdef __cplusplus
}
#endif
