/* UARTs/AT91/driver.h
UART driver for the Atmel AT91 board
(C) 2000 N. Douglas
9th March 2000
*/

#include "Core/ARM/common.h"

#ifdef __cplusplus
extern "C" {
#endif

extern HALError *AT91UARTDriver_Initialise(HALUARTBlk *blk, void *addr, int id);

extern HALError *AT91UARTDriver_Finalise(HALUARTBlk *blk);

extern HALError *AT91UARTDriver_Set(HALUARTBlk *blk, u32 baud, u8 bits, u8 parity, u8 stopbits);

extern HALError *AT91UARTDriver_WriteN(HALUARTBlk *blk, char *buff, int length);

extern HALError *AT91UARTDriver_GetIOStatus(HALUARTBlk *blk, s32 *txsize, s32 *rxsize);

extern HALError *AT91UARTDriver_ReadN(HALUARTBlk *blk, char *buff, int length);

#ifdef __cplusplus
}
#endif
