; UARTs/Angel/driver.s
; Angel UART driver
;
; 01/Oct/1999 ned


	
	AREA	AngelUARTDriver, CODE, READONLY

	; Include common includes
	INCLUDE	CommonH.s

	[ :DEF: ANGEL

	; Exports from this module
	EXPORT	AngelUARTDriver_Initialise
	EXPORT	AngelUARTDriver_Finalise
	EXPORT	AngelUARTDriver_WriteN
	EXPORT	AngelUARTDriver_ReadN

AngelUARTDriver_Initialise
	; R0=ptr to UART block
	; R1=addr of UART (not applicable here)
	; R2=uart id (not applicable here)
	STR	R1,[R0,#HALUARTBLK_UARTADDR]
	MOV	R0,#0
	MOV	PC,R14

AngelUARTDriver_Finalise
	; R0=ptr to UART block
	STMFD	R13!,{R1}
	MOV	R1,#0
	STR	R1,[R0,#HALUARTBLK_UARTADDR]
	MOV	R0,#0
	LDMFD	R13!,{R1}
	MOV	PC,R14

AngelUARTDriver_WriteN
	; R0=ptr to UART block
	; R1=ptr to ASCII string
	; R2=chars to write
	STMFD	R13!,{R1-R3}
	MOV	R3,R1
1
	MOV	R0,#angel_SWIreason_WriteC
	MOV	R1,R3
	SWI	0x123456
	ADD	R3,R3,#1
	SUBS	R2,R2,#1
	BNE	%b01
	MOV	R0,#0				; no error
	LDMFD	R13!,{R1-R3}
	MOV	PC,R14

AngelUARTDriver_ReadN
	; R0=ptr to UART block
	; R1=ptr to buffer
	; R2=chars to read
	STMFD	R13!,{R1-R3}
	MOV	R3,R1
1
	MOV	R0,#angel_SWIreason_ReadC
	SWI	0x123456
	STRB	R0,[R3],#1
	SUBS	R2,R2,#1
	BNE	%b01
	MOV	R0,#0
	LDMFD	R13!,{R1-R3}
	MOV	PC,R14

	]
	END